unit NumEdit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TNumEdit = class(TEdit)
  private
    { Private declarations }
    FHexaChars: Boolean;
    procedure SetHexaChars (NewHexaChars: Boolean);
  protected
    { Protected declarations }
    procedure Change; override;
    procedure KeyPress (var Key: Char); override;
    procedure MyChange;
  public
    { Public declarations }
    constructor Create (AOwner: TComponent); override;
  published
    { Published declarations }
    property EnableHexa: Boolean read FHexaChars write SetHexaChars;
  end;

procedure Register;

implementation

procedure TNumEdit.SetHexaChars (NewHexaChars: Boolean);
begin {}
  if FHexaChars = NewHexaChars then exit;
  FHexaChars := NewHexaChars;
  if FHexaChars = False then MyChange;
end; {}

constructor TNumEdit.Create (AOwner: TComponent);
begin
  inherited Create (AOwner);
  FHexaChars{EnableHexa} := True;
  Text := '1';
end;

procedure TNumEdit.MyChange;
var
  s: string;
  i: integer;
  C: set of char;
begin {}
  s := '';
  if FHexaChars then C := ['0'..'9','A'..'F','a'..'f']
  else C := ['0'..'9'];

  for i := 1 to length (Text) do
    if  Text [i] in C then S := S + text [i];
  if S <> Text then Text := s;
end; {}


procedure TNumEdit.Change;
begin
  MyChange;
  inherited Change;
end;

procedure TNumEdit.KeyPress (var Key: Char);
begin
  if not ((FHexaChars and (Key in [^C, ^V, ^X, #8,'0'..'9','a'..'f','A'..'F']))
     or (not FHexaChars and (Key in [^C, ^V, ^X, #8,'0'..'9']))) then Key := #0;
  inherited KeyPress (Key);
end;

procedure Register;
begin
  RegisterComponents('Standard', [TNumEdit]);
end;

end.


